/** 
 * Copyright (c) 2010, Regents of the University of Colorado 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer. 
 * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution. 
 * Neither the name of the University of Colorado at Boulder nor the names of its contributors may be used to endorse or promote products derived from this software without specific prior written permission. 
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE. 
 */
package org.cleartk.srl.feature;

import java.util.ArrayList;
import java.util.List;

import org.apache.uima.jcas.JCas;
import org.apache.uima.jcas.tcas.Annotation;
import org.cleartk.classifier.Feature;
import org.cleartk.classifier.feature.extractor.simple.SimpleFeatureExtractor;
import org.cleartk.ne.type.NamedEntityMention;
import org.uimafit.util.JCasUtil;

/**
 * <br>
 * Copyright (c) 2010, Regents of the University of Colorado <br>
 * All rights reserved.
 * 
 * 
 * @author Philipp Wetzler
 * @deprecated the SRL code is going away due to neglect and incompleteness
 */
@Deprecated
public class NamedEntityExtractor implements SimpleFeatureExtractor {

  public List<Feature> extract(JCas view, Annotation focusAnnotation) {
    List<NamedEntityMention> nems = JCasUtil.selectCovered(
        view,
        NamedEntityMention.class,
        focusAnnotation);

    // look for perfect match to NE first
    for (NamedEntityMention nem : nems) {
      if (nem.getBegin() == focusAnnotation.getBegin() && nem.getEnd() == focusAnnotation.getEnd()) {
        List<Feature> features = new ArrayList<Feature>();
        features.add(new Feature("NamedEntityType", nem.getMentionType()));
        features.add(new Feature("IsNamedEntity", true));
        features.add(new Feature("IsContainedByNamedEntity", false));
        return features;
      }
    }

    // look for contained NEs
    for (NamedEntityMention nem : nems) {
      List<Feature> features = new ArrayList<Feature>();
      features.add(new Feature("ContainingNamedEntityType", nem.getMentionType()));
      features.add(new Feature("IsNamedEntity", false));
      features.add(new Feature("IsContainedByNamedEntity", true));
      return features;
    }

    // no contained NEs
    List<Feature> features = new ArrayList<Feature>();
    features.add(new Feature("IsNamedEntity", false));
    features.add(new Feature("IsContainedByNamedEntity", false));
    return features;
  }
}
